/* -*- Mode: C++ -*-
   vi:si:et:sw=4:sts=4:ts=4
 */
/*
  kerbsystray - A systray util to list kerberos tickets on Windows
  Copyright (C) 2007 Michele Baldessari <michele@pupazzo.org>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/

#define SECURITY_WIN32
#define DEBUG
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <Ntsecapi.h>

char *
char_to_hex(const char *str);

// FIXME: Throw exception in constructor instead of current hack
class KerberosUtilClass
{
public:
	KerberosUtilClass ();
	~KerberosUtilClass ();
	BOOL isInitialized ();
	BOOL purgeAllTickets ();
	BOOL refreshKerberosTicketCache ();
	unsigned int getTicketCacheCount ();
	BOOL getTicketFromCache (unsigned int ticket_nr, PKERB_TICKET_CACHE_INFO ticket);
	BOOL getMSCacheTicketFromCacheInfo(unsigned int ticket_nr, PKERB_EXTERNAL_TICKET *ticket);
protected:
	HANDLE LsaLogon;
	ULONG AuthPackage;
	BOOL Initialized;
	PKERB_QUERY_TKT_CACHE_RESPONSE pTicketCacheResponse;
};
